//
// 1 2 3 4 5 6 7 8 910111213141516171819
//¤äĤŤƤǤȤɤʤˤ̤ͤΤϤФѤҤ
// 1 2 3 4 5 6 7 8 9101112131415161718192021
//
// 1 2 3 4 5 6 7 8 9101112131415161718192021222324252627
        
public class HangulAutomata
{
	private static final int STATE_EMPTY = 0;
	private static final int STATE_CHOSUNG = 1;
	private static final int STATE_JUNGSUNG = 2;
	private static final int STATE_JONGSUNG = 3;

	private static final int CODE_CHOSUNG = 0;
	private static final int CODE_JUNGSUNG = 1;
	private static final int CODE_JONGSUNG = 2;
	private static final int CODE_SPECIAL = 3;
	private static final int CODE_BACKSPACE = 4;

	private static final char[] CHOSUNG_UNICODE_TRANS = 
	{ 
		'\u0000', 
		'\u3131', '\u3132', '\u3134', '\u3137', '\u3138',
		'\u3139', '\u3141', '\u3142', '\u3143', '\u3145',
		'\u3146', '\u3147', '\u3148', '\u3149', '\u314A',
		'\u314B', '\u314C', '\u314D', '\u314E'
	};

	private static final char[] JONGSUNG_UNICODE_TRANS = 
	{
		'\u0000',
		'\u3131', '\u3132', '\u3133', '\u3134', '\u3135', 
		'\u3136', '\u3137', '\u3139', '\u313A', '\u313B', 
		'\u313C', '\u313D', '\u313E', '\u313F', '\u3140', 
		'\u3141', '\u3142', '\u3144', '\u3145', '\u3146', 
		'\u3147', '\u3148', '\u314A', '\u314B', '\u314C', 
		'\u314D', '\u314E'
	};

	private static final int[] CHOSUNG_JONGSUNG_TRANS = 
	{
		0,
		1, 2, 4, 7, 0,
		8, 16, 17, 0, 19, 
		20, 21, 22, 0, 23, 
		24, 25, 26, 27
	};

//
// 1 2 3 4 5 6 7 8 910111213141516171819
//¤äĤŤƤǤȤɤʤˤ̤ͤΤϤФѤҤ
// 1 2 3 4 5 6 7 8 9101112131415161718192021
//
// 1 2 3 4 5 6 7 8 9101112131415161718192021222324252627
	private static final int[][] JONGSUNG_CHOSUNG_TRANS = 
	{
		{0, 0},
		{0, 1}, {0, 2}, {1, 10}, {0, 3}, {4, 13},
		{4, 19}, {0, 4}, {0, 6}, {8, 1}, {8, 7},
		{8, 8}, {8, 10}, {8, 17}, {8, 18}, {8, 19},
		{0, 7}, {0, 8}, {17, 10}, {0, 10}, {0, 11},
		{0, 12}, {0, 13}, {0, 15}, {0, 16}, {0, 17},
		{0, 18}, {0, 19}
	};

	private boolean bDuBulSik;
	private int state;
	private char code1;
	private char code2;
	private int chosung;
	private int jungsung;
	private int jongsung;
	
	private char[] completed = new char[2];

	public HangulAutomata()
	{
		bDuBulSik = true;
	}

	public HangulAutomata(boolean dbs)
	{
		bDuBulSik = dbs;
	}

	public void setDuBulSik(boolean dbs)
	{
		bDuBulSik = dbs;
	}

	public boolean isDuBulSik()
	{
		return bDuBulSik;
	}
/*
	public char getChar()
	{
		char result;

		result = code1;
		code1 = code2;
		code2 = '\u0000';
		return result;
	}
*/
	public char[] getCompletedChars()
	{
		completed[0] = code1;
		completed[1] = code2;
		code1 = code2 = '\u0000';
		return completed;
	}
			
	public char getTransientChar()
	{
		switch (state)
		{
		case STATE_EMPTY:
			return '\u0000';
		case STATE_CHOSUNG:
//			return (char)(0x3130 + chosung);
			return CHOSUNG_UNICODE_TRANS[chosung];
		default:
			return (char)(chosung * 588 + jungsung * 28 + jongsung + 0xAC00 - 588 - 28);
		}
	}
	
	public boolean isTransient()
	{
		return state != STATE_EMPTY;
	}

	public char forceCompletion()
	{
		char result;
		
		result = getTransientChar();
		state = STATE_EMPTY;
		chosung = jungsung = jongsung = 0;
		code1 = code2 = '\u0000';
		
		return result;
	}
	
	public void setChar(char c)
	{
		int type;
		int bul;
		int code;

		if (bDuBulSik)
		{
			type = getType2(c);
			bul = type >> 8;
			code = type & 0x00FF;

			switch (state)
			{
			case STATE_EMPTY:
				switch (bul)
				{
				case CODE_CHOSUNG: state = STATE_CHOSUNG; chosung = code; return;
				case CODE_JUNGSUNG: state = STATE_EMPTY; code1 = (char)(0x314E + code); return;
				case CODE_SPECIAL: state = STATE_EMPTY; code1 = c; return;
				case CODE_BACKSPACE: 
					if (code2 != '\u0000')
						code2 = '\u0000';
					else 
						code1 = '\u0000';
				}
				break;
			case STATE_CHOSUNG:
				switch (bul)
				{
				case CODE_CHOSUNG: state = STATE_CHOSUNG; code1 = CHOSUNG_UNICODE_TRANS[chosung]; chosung = code; return;
				case CODE_JUNGSUNG: state = STATE_JUNGSUNG; jungsung = code; return;
				case CODE_SPECIAL: state = STATE_EMPTY; code1 = CHOSUNG_UNICODE_TRANS[chosung]; 
					code2 = c; chosung = 0; return;
				case CODE_BACKSPACE: state = STATE_EMPTY; chosung = 0; return;
				}
				break;
			case STATE_JUNGSUNG:
				switch (bul)
				{
				case CODE_CHOSUNG:
					jongsung = CHOSUNG_JONGSUNG_TRANS[code];
					if (jongsung == 0)
					{
						state = STATE_CHOSUNG;
						code1 = (char)(chosung * 588 + jungsung * 28 + 43416);
						chosung = code;
						jungsung = jongsung = 0;
						return;
					}
					else
					{
						state = STATE_JONGSUNG;
						return;
					}
						
/*					
					switch (code)
					{
					case 5:
					case 9:
					case 14:
						state = STATE_CHOSUNG; 
						code1 = (char)(chosung * 588 + jungsung * 28 + 43416);
						chosung = code;
						return;
					}
					state = STATE_JONGSUNG; 
					jongsung = code;
					return;
*/					
				case CODE_JUNGSUNG:
					switch (jungsung)
					{
					case 9:
						switch (code)
						{
						case 1: jungsung = 10; return;
						case 2: jungsung = 11; return;
						case 21: jungsung = 12; return;
						}
						break;
					case 14:
						switch (code)
						{
						case 5: jungsung = 15; return;
						case 6: jungsung = 16; return;
						case 21: jungsung = 17; return;
						}
						break;
					case 19:
						if (code == 21)
						{
							jungsung = 20;
							return;
						}
						break;
					}
					state = STATE_EMPTY;
					code1 = (char)(chosung * 588 + jungsung * 28 + 43416);
					code2 = (char)(0x314E + code);
					chosung = jungsung = 0;
					return;
				case CODE_SPECIAL:
					state = STATE_EMPTY;
					code1 = (char)(chosung * 588 + jungsung * 28 + 43416);
					code2 = c;
					chosung = jungsung = 0;
					return;
				case CODE_BACKSPACE:
					switch (jungsung)
					{
					case 10: case 11: case 12: jungsung = 9; return;
					case 15: case 16: case 17: jungsung = 14; return;
					case 20: jungsung = 19; return;
					}
					state = STATE_CHOSUNG; 
					jungsung = 0; 
					return;
				}
				break;
			case STATE_JONGSUNG:
				switch (bul)
				{
				case CODE_CHOSUNG:
					switch (jongsung)
					{
					case 1:
						if (code == 10)
						{
							jongsung = 3;
							return;
						}
						break;
					case 4:
						switch (code)
						{
						case 13: jongsung = 5; return;
						case 19: jongsung = 6; return;
						}
						break;
					case 8:
						switch (code)
						{
						case 1: jongsung = 9; return;
						case 7: jongsung = 10; return;
						case 8: jongsung = 11; return;
						case 10: jongsung = 12; return;
						case 17: jongsung = 13; return;
						case 18: jongsung = 14; return;
						case 19: jongsung = 15; return;
						}
						break;
					case 17:
						if (code == 10)
						{
							jongsung = 18;
							return;
						}
						break;
					}
					state = STATE_CHOSUNG;
					code1 = (char)(chosung * 588 + jungsung * 28 + jongsung + 43416);
					chosung = code;
					jungsung = jongsung = 0;
					return;
				case CODE_JUNGSUNG:
					state = STATE_JUNGSUNG;
					code1 = (char)(chosung * 588 + jungsung * 28 + JONGSUNG_CHOSUNG_TRANS[jongsung][0] + 43416); 
					chosung = JONGSUNG_CHOSUNG_TRANS[jongsung][1];
					jungsung = code;
					jongsung = 0;
					return;
				case CODE_SPECIAL:
					state = STATE_EMPTY;
					code1 = (char)(chosung * 588 + jungsung * 28 + jongsung + 43416);
					code2 = c;
					chosung = jungsung = jongsung = 0;
					return;
				case CODE_BACKSPACE:
					switch (jongsung)
					{
					case 3: jongsung = 1; return;
					case 5:
					case 6: jongsung = 4; return;
					case 9: 
					case 10:
					case 11:
					case 12:
					case 13:
					case 14:
					case 15: jongsung = 8; return;
					case 18: jongsung = 17; return;
					}
					state = STATE_JUNGSUNG;
					jongsung = 0;
					return;
				}
			}
		}
	}

	private int getType2(char c)
	{
		switch (c)
		{
		case 'r': return 0x0001;
		case 'R': return 0x0002;
		case 's': case 'S': return 0x0003;
		case 'e': return 0x0004;
		case 'E': return 0x0005;
		case 'f': case 'F': return 0x0006;
		case 'a': case 'A': return 0x0007;
		case 'q': return 0x0008;
		case 'Q': return 0x0009;
		case 't': return 0x000a;
		case 'T': return 0x000b;
		case 'd': case 'D': return 0x000c;
		case 'w': return 0x000d;
		case 'W': return 0x000e;
		case 'c': case 'C': return 0x000f;
		case 'z': case 'Z': return 0x0010;
		case 'x': case 'X': return 0x0011;
		case 'v': case 'V': return 0x0012;
		case 'g': case 'G': return 0x0013;

		case 'k': case 'K': return 0x0101;
		case 'o': return 0x0102;
		case 'i': case 'I': return 0x0103;
		case 'O': return 0x0104;
		case 'j': case 'J': return 0x0105;
		case 'p': return 0x0106;
		case 'u': case 'U': return 0x0107;
		case 'P': return 0x0108;
		case 'h': case 'H': return 0x0109;
		case 'y': case 'Y': return 0x010d;
		case 'n': case 'N': return 0x010e;
		case 'b': case 'B': return 0x0112;
		case 'm': case 'M': return 0x0113;
		case 'l': case 'L': return 0x0115;
		case '\b': return 0x0400;
		default: return 0x0300;
		}
	}
/*
	private int getType3(char c)
	{
		switch (c)
		{
		case 'k': return 0x0001;
		case 'h': return 0x0003;
		case 'u': return 0x0004;
		case 'y': return 0x0006;
		case 'i': return 0x0007;
		case ';': return 0x0008;
		case 'n': return 0x000a;
		case 'j': return 0x000c;
		case 'l': return 0x000d;
		case 'o': return 0x000f;
		case '0': return 0x0010;
		case '\'': return 0x0011;
		case 'p': return 0x0012;
		case 'm': return 0x0013;

//¤äĤŤƤǤȤɤʤˤ̤ͤΤϤФѤҤ
// 1 2 3 4 5 6 7 8 9101112131415161718192021
		case 'f':
		case 'r':
		case '6':
		case 'R':
		case 't':
		case 'c':
		case 'e':
		case '7':
		case 'v':
		case '4':
		case 'b':
		case '5':
		case 'g':
		case '8':
		case 'd':

*/
}
