// Clipboard.cpp: implementation of the CClipboard class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "IMEsebol.h"
#include "Clipboard.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CClipboard::CClipboard(HWND hWnd)
{
	m_hWnd = hWnd;
	if (m_hWnd)
		::OpenClipboard(m_hWnd);

	m_hMem = NULL;
	m_pStr = NULL;
}

CClipboard::~CClipboard()
{
	if (m_hWnd)
		::CloseClipboard();

	if (m_hMem) {
		if (m_pStr) {
			GlobalUnlock(m_hMem);
		}
		GlobalFree(m_hMem);
	}
}

BOOL CClipboard::Copy(LPCTSTR pszStr)
{
	BOOL b = ::EmptyClipboard();
	if (!b)
		return FALSE;

	DWORD len = lstrlen(pszStr) + 1;
	DWORD cb = len * sizeof (TCHAR);

	if (m_hMem) {
		if (m_pStr) {
			GlobalUnlock(m_hMem);
		}
		GlobalFree(m_hMem);
	}

	m_hMem = GlobalAlloc(GMEM_MOVEABLE, cb);
	if (!m_hMem)
		return FALSE;

	m_pStr = (LPTSTR)GlobalLock(m_hMem);
	if (!m_pStr)
		return FALSE;

	lstrcpy(m_pStr, pszStr);

	b = GlobalUnlock(m_hMem);
	if (!b) {
		DWORD dw = GetLastError();
		if (dw != 0)
			return FALSE;
	}

	m_pStr = NULL;
	HANDLE h = SetClipboardData(CF_TEXT, m_hMem);
	if (h)
		m_hMem = NULL;

	return TRUE;
}
